deferred class EDGES[K]

inherit VIEW[VERTICES[K]]

feature {NONE} -- Creation

	make (m: like model) is
	deferred
	end

feature -- edge operations

	add (v1, v2: VERTEX[K]) is
		-- agrega una arista entre `v1' y `v2'
	require
		not has (v1, v2)
	deferred
	ensure
		has (v1, v2)
	end

	remove (v1, v2: VERTEX[K]) is
		-- quita la arista entre `v1' y `v2'
	require
		has (v1, v2)
	deferred
	ensure
		not has (v1, v2)
	end

	has (v1, v2: VERTEX[K]): BOOLEAN is
		-- hay una arista entre `v1' y `v2'?
	deferred
	end

	at (v: VERTEX[K]): ITERATOR[VERTEX[K]] is
		-- {w: has(`v', w)}
	deferred
	end

	count (v: VERTEX[K]): INTEGER is
		-- | at(v) |
	local
		ii: ITERATOR[VERTEX[K]]
	do
		from
			ii := at (v)
		until
			ii.is_off
		loop
			Result := Result + 1
			ii.next
		end
	end

end -- class EDGES[K]
