class TEST_WEIGHTED

creation make

feature {NONE}

	item: STRING

	create_graph is
	do
		create g.make
		create v1.from_parent (g, "Crdoba")
		create v2.from_parent (g, "Rosario")
		create v3.from_parent (g, "Paran")
		create v4.from_parent (g, "Buenos Aires")
		g.add_edge (v1, v2, 10)
		g.add_edge (v2, v3, 1)
		g.add_edge (v1, v3, 50)
		g.add_edge (v3, v4, 5)
		g.add_edge (v2, v4, 10)
	end

	v1, v2, v3, v4: VERTEX_INDEX[like item]

	g: WEIGHTED_DIRECTED_GRAPH[INTEGER, STRING, EDGES_MATRIX[STRING]]

feature

	make is
	local
		graph_io: INPUT_OUTPUT[STRING]
	do
		create_graph
		print ("v1 ~ v2 = " + g.shortest_path (v1, v2).to_string + "%N")
		print ("v1 ~ v3 = " + g.shortest_path (v1, v3).to_string + "%N")
		print ("v1 ~ v4 = " + g.shortest_path (v1, v4).to_string + "%N")
		print ("Kruscal = " + g.kruscal.count.to_string + "%N")
		graph_io.put (g, io)
	end

end -- class TEST_WEIGHTED
