class UNDIRECTED_GRAPH[K, E->EDGES[K]]

inherit
	GRAPH[K, E]

creation make

feature -- operations

	add_edge(v1, v2: VERTEX[K]) is
	do
		if not edges.has (v1, v2) then
			edges.add (v1, v2)
		end
		if not edges.has (v2, v1) then
			edges.add (v2, v1)
		end
	end

	remove_edge(v1, v2: VERTEX[K]) is
	do
		if edges.has (v1, v2) then
			edges.remove (v1, v2)
		end
		if edges.has (v2, v1) then
			edges.remove (v2, v1)
		end
	end

feature -- Output

	output_header: STRING is "graph"

	output_unweighted_edge (v1, v2: VERTEX[K]): STRING is
	do
		Result := v1.index.to_string + " - " + v2.index.to_string
	end

end -- class UNDIRECTED_GRAPH[K, E]
