class FLOW[K, W->DOUBLE]
	-- una funcion f definida sobre los lados de un network

feature -- Creation

	from_network (n: like network) is
	do
		network := n
		create flow.make (1, n.count, 1, n.count)
	end

feature -- Operations

	augment (f: like Current) is
		-- suma `f' al flujo actual
	local
		ii: ITERATOR[WEIGHTED_EDGE[K, W]]
		w: W
		i, j: VERTEX[K]
	do
		from
			ii := network.get_new_iterator_on_edges
		until
			ii.is_off
		loop
			i := ii.item.source
			j := ii.item.target
			w := flow.item (i.index, j.index)
			if network.are_adjacents (i, j) then
				w := w + f.weight (i, j)
			else
				w := w - f.weight (i, j)
			end
			flow.put (w, i.index, j.index)
			ii.next
		end
	end

	augment_path (path: PATH[K]; f: W) is
		-- aumenta `Current' a traves de `path'
	do
		from
			--path.start
		until
			True --path.is_off
		loop
			-- TODO ->
			-- flow.item (path.item, path.
			--path.next
		end
	end

	weight (i, j: VERTEX[K]): W is
		-- flujo de `i' a `j'
	do
		Result := flow.item (i.index, j.index)
	end

feature {NONE} -- Representation

	network: NETWORK[K, W]

	flow: ARRAY2[W]

end -- class FLOW[K, W]
