deferred class VIEW[G->MODEL]

feature -- Access

	model: G

feature -- Operations

	set_model(new_model: G) is
	require
		new_model /= Void implies new_model = model or not new_model.views.fast_has(Current)
	do
		if model /= Void then
			model.remove_view(Current)
		end
		model := Void
		if new_model /= Void then
			new_model.add_view(Current)
			model := new_model
		end
	ensure
		model = new_model
	end

feature -- Callbacks

	on_model_change is
	deferred
	end

invariant

	model /= Void implies model.views.fast_has(Current)

end -- class VIEW
