deferred class DISPENSER[E]

feature -- Operations

	add (e: E) is
	deferred
	ensure
		not is_empty
	end

	remove is
	require
		not is_empty
	deferred
	end

	item: E is
	require
		not is_empty
	deferred
	end

	is_empty: BOOLEAN is
	deferred
	end

	clear is
	do
		from
		until
			is_empty
		loop
			remove
		end
	ensure
		is_empty
	end

end -- class DISPENSER
