class FOREST

creation make

feature -- Creation

	make (c: INTEGER) is
	do
		create storage.make (1, c)
		count := c
	end

feature -- Operations

	are_connected (i, j: INTEGER): BOOLEAN is
	do
		Result := find (i) = find (j)
	end

	union (i, j: INTEGER) is
	local
		rep, rep2: INTEGER
	do
		rep := find (i)
		rep2 := find (j)
		if storage @ rep > storage @ rep2 then
			storage.put (rep2, rep)
		else
			storage.put (rep, rep2)
		end
		count := count - 1
	end

	count: INTEGER

feature {NONE} -- Internal

	find (index: INTEGER): INTEGER is
	do
		from
			Result := index
		until
			storage @ Result < 0
		loop
			Result := storage @ Result
		end
	end

	storage: ARRAY[INTEGER]

end -- class FOREST