class STACK[E]

inherit DISPENSER[E]

creation make

feature -- Representation

	storage: LINKED_LIST[E]

feature -- Creation

	make is
	do
		create storage.make
	end

feature -- Operations

	add (e: E) is
	do
		storage.add_last (e)
	ensure then
		item = e
	end

	remove is
	do
		storage.remove_last
	end

	item: E is
	do
		Result := storage.last
	end

	is_empty: BOOLEAN is
	do
		Result := storage.is_empty
	end

end -- class STACK
