deferred class VISITOR[K]

inherit ITERATOR[VERTEX[K]]

feature {NONE}

	graph: GRAPH[K, EDGES[K]]

	first: like item

	dispenser: DISPENSER[EDGE[K]]
		-- guarda el par <parent, item>

feature -- iterator operations

	make(g: like graph; init: like item) is
	do
		graph := g
		first := init
		start
	end

	start is
	do
		dispenser.clear
		dispenser.add (create {EDGE[K]}.make (Void, first))
		item := first
		next
	end

	is_off: BOOLEAN is
	do
		Result := dispenser.is_empty
	end

	item2: VERTEX[K] is
	do
		Result := actual.target
	end

	parent2: like item is
	do
		Result := actual.source
	end

	item: VERTEX[K]

	parent: like item

	next is
	local
		ii: ITERATOR[like item]
		v: like item
	do
		from
			item := Void
		until
			item /= Void or is_off
		loop
			v := dispenser.item.target
			parent := dispenser.item.source
			dispenser.remove
			if test (v) then
				item := v
				from
					ii := childs (v)
				until
					ii.is_off
				loop
					dispenser.add (create {EDGE[K]}.make (v, ii.item))
					ii.next
				end
				action (v)
			end
		end
	end

feature {NONE} -- Implementation

	actual: EDGES[K]

feature {NONE} -- deferred features

	test (v: like item): BOOLEAN is
	deferred
	end

	action (v: like item) is
	deferred
	end

	childs (v: VERTEX[K]): ITERATOR[VERTEX[K]] is
	deferred
	end

end
