class EDGE[K]

inherit HASHABLE

creation make

feature {NONE} -- creation

	make (v1, v2: VERTEX[K]) is
		-- constructor
	do
		source := v1
		target := v2
	end

feature -- access

	source, target: VERTEX[K]
		-- vertices

feature -- hash code

	hash_code: INTEGER is
	do
		Result := v1.hash_code * 1000 + v2.hash_code
	end

end -- class EDGE[K]