class WEIGHTED_EDGE[W->DOUBLE, K]

inherit
	COMPARABLE
	EDGE[K]
		rename make as make_old
		undefine is_equal
		end

creation make

feature {NONE} -- creation

	make (v1, v2: VERTEX[K]; w: W) is
	do
		make_old (v1, v2)
		weight := w
	end

feature -- access

	weight: W
		-- peso

feature -- comparation

	infix "<" (other: like Current): BOOLEAN is
	do
		Result := weight < other.weight
	end

end -- class WEIGHTED_EDGE[K, W->DOUBLE]