class WEIGHTED_DIRECTED_GRAPH[W->DOUBLE, K, E->EDGES[K]]

inherit
	WEIGHTED_GRAPH[W, K, E]
		redefine add_edge
		end
	DIRECTED_GRAPH[K, E]
		rename add_edge as add_edge_old, remove_edge as remove_edge_old
		undefine get_new_iterator_on_edges, make, from_graph, put_edge, add_vertex, output_edge
		end

creation make

feature -- operations

	add_edge (v1, v2: VERTEX[K]; w: W) is
	do
		Precursor (v1, v2, w)
		weights.put (w, v1.index, v2.index)
	end

end -- class WEIGHTED_DIRECTED_GRAPH[K, E, W]
