class ITERATOR_ADJACENTS[K]

inherit ITERATOR[VERTEX[K]]

creation make

feature {NONE}

	verts: VERTICES[K]

	edges: EDGES[K]

	vertex: VERTEX[K]

	vertices: ITERATOR[VERTEX[K]]

feature

	make(ve: like verts; e: like edges; v: VERTEX[K]) is
	do
		verts := ve
		edges := e
		vertex := v
		start
	end

	start is
	do
		vertices := verts.get_new_iterator
		locate
	end

	is_off: BOOLEAN is
	do
		Result := vertices.is_off
	end

	item: VERTEX[K] is
	do
		Result := vertices.item
	end

	next is
	do
		vertices.next
		locate
	end

feature {NONE} -- Internal

	locate is
	do
		from
		until
			vertices.is_off or else edges.has (vertex, vertices.item)
		loop
			vertices.next
		end
	end

end
