class ITERATOR_EDGES[K]

inherit ITERATOR[EDGE[K]]

creation make

feature {NONE}

	graph: GRAPH[K, EDGES[K]]

	vertices, adjacents: ITERATOR[VERTEX[K]]

feature

	make(g: like graph) is
	do
		graph := g
		start
	end

	start is
	do
		vertices := graph.get_new_iterator
		if not vertices.is_off then
			adjacents := graph.adjacents (vertices.item)
		end
	end

	is_off: BOOLEAN is
	do
		Result := vertices.is_off or adjacents.is_off
	end

	item: EDGE[K] is
	do
		create Result.make (vertices.item, adjacents.item)
	end

	next is
	do
		adjacents.next
		if adjacents.is_off then
			from
			until
				vertices.is_off or not adjacents.is_off
			loop
				vertices.next
				if not vertices.is_off then
					adjacents := graph.adjacents (vertices.item)
				end
			end
		end
	end

end
