class ITERATOR_GREEDY[K]

inherit ITERATOR[VERTEX[K]]

creation make

feature {NONE}

	graph: GRAPH[K, EDGES[K]]

	grados: DICTIONARY[INTEGER, VERTEX[K]]

	actual: VERTEX[K]

feature

	make(g: like graph) is
	do
		graph := g
		create grados.make
		start
	end

	start is
	local
		ii: ITERATOR[VERTEX[K]]
	do
		from
			ii := graph.get_new_iterator
		until
			ii.is_off
		loop
			grados.put (graph.grado (ii.item), ii.item)
			ii.next
		end
	end

	is_off: BOOLEAN is
	do
		Result := actual = Void
	end

	item: VERTEX[K] is
	do
		Result := actual
	end

	next is
	local
		ii: ITERATOR[VERTEX[K]]
	do
		grados.remove (actual)
		from
			ii := graph.adjacents (actual)
		until
			ii.is_off
		loop
			grados.put (grados@(ii.item)-1, ii.item)
			ii.next
		end
		from
			ii := grados.get_new_iterator_on_keys
			actual := Void
		until
			ii.is_off
		loop
			if actual = Void or else grados@actual > grados@(ii.item) then
				actual := ii.item
			end
			ii.next
		end
	end

end
