class ITERATOR_UNION[K]

inherit ITERATOR[K]

creation make

feature {NONE} -- Internal

	first, second, actual: ITERATOR[K]

feature

	make(f, s: ITERATOR[K]) is
	require
		f /= Void
		s /= Void
	do
		first := f
		second := s
		start
	end

	start is
	do
		first.start
		second.start
		actual := second
	end

	is_off: BOOLEAN is
	do
		Result := actual = second and second.is_off
	end

	item: K is
	do
		Result := actual.item
	end

	next is
	do
		actual.next
		if actual.is_off and actual = first then
			actual := second
		end
	end

end
