class LAYERED_NETWORK[K, W->DOUBLE]
	-- no tiene lados backward

inherit
	NETWORK[K, W]
		redefine get_max_flow
		end

creation from_network

feature -- Algorithms

	get_max_flow: FLOW[K, W] is
		-- dinic
	local
		paths: ITERATOR_PATHS[K]
	do
		from
			create paths.make (Current, source)
		until
			paths.is_off
		loop
			-- Result.augment_path (paths.item)
			paths.next
		end
	end

feature {NONE} -- Creation

	from_network (f: FLOW[K, W]) is
		-- obtiene el network auxiliar a partir del network y un flujo
	local
		bfs: LAYERED[K]
	do
		add_vertex (source)
		from
			create bfs.make (Current, source, sink)
			bfs.next -- saltea `source'
		until
			bfs.is_off
		loop
			if not has (bfs.item) then
				add_vertex (bfs.item)
			end
			-- TODO
			if True then -- bfs.foreward then
				add_edge (bfs.parent, bfs.item, weight (bfs.parent, bfs.item))
			else
				add_edge (bfs.parent, bfs.item, weight (bfs.item, bfs.parent))
			end
			bfs.next
		end
	end

end -- class LAYERED_NETWORK[K, W]
