class PRIORITY_QUEUE[K->COMPARABLE]

creation make

feature{NONE}

	elems: ARRAY[K]

	count: INTEGER

feature

	make is
	do
		create elems.make(1,0)
		count := 0
	end

	add(e: K) is
	local
		p, q: INTEGER
	do
		count := count + 1
		elems.add_last(e)
		from
			p := count
			q := count // 2
		until p = 1 or else elems@p >= elems@q
		loop
			elems.swap(p,q)
			p := q
			q := q // 2
		end
	end

	item: K is
	do
		Result := elems@1
	end

	is_empty: BOOLEAN is
	do
		Result := (count = 0)
	end

	remove is
	local
		d, p, i: INTEGER
	do
		elems.put(elems@count, 1)
		count := count - 1
		from
			p := 1
			i := 2
			d := 3
		until
			d > count or else (elems@i >= elems@p and elems@d >= elems@p)
		loop
			if elems@d >= elems@i then
				elems.swap(p,i)
				p := i
			else--if elems@d < elems@i then
				elems.swap(d,p)
				p := d
			end
			i := 2*p
			d := i + 1
		end
		if i <= count then
			if elems@i < elems@p then
				elems.swap(i,p)
			end
		end
	end

end --class PRIORITY_QUEUE

