class LAYERED[K]

inherit
	VISITOR[K]
		rename make as make_vertices
		redefine start, is_off
		end

creation make

feature {NONE}

	level: DICTIONARY[INTEGER, VERTEX[K]]

	last: VERTEX[K]

feature

	make(g: like graph; f, l: VERTEX[K]) is
	do
		create {QUEUE[EDGE[K]]} dispenser.make
		last := l
		make_vertices (g, f)
	end

	start is
	do
		Precursor
		create level.make
		level.put (0, first)
	end

	is_off: BOOLEAN is
	do
		Result := Precursor or item = last
	end

feature {NONE} -- agents

	test (v: like item): BOOLEAN is
	do
		Result := not level.has (item) or else level.at (item) > level.at (v)
	end

	action (v: like item) is
	do
		level.put (level.at (item) + 1, v)
	end

end
